﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Controls.Primitives;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace GameOfLive {
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window {

        private string C_REG_ADR = "SOFTWARE\\WILHELM\\GameOfLive";


        private String windowname = "mainWindow";
        private bool start = true;

        private ToggleButton[,] cells;
        private bool[,] cells1;
        private bool[,] cells2;

        private bool firstStep = true;
        private int cols = 0;
        private int rows = 0;

        public MainWindow() {
            InitializeComponent();
        }

        private void Window_Loaded(Object sender, RoutedEventArgs e) {
            Basis.setWindowPositionFromRegistry(this, C_REG_ADR, windowname);
            createGrid(10, 10);
            start = false;
        }


      

        private void cbFont_SelectionChanged(Object sender, SelectionChangedEventArgs e) {
            if (!start && cbFont.SelectedIndex>=0) {
                int fonzsize = 12 + (cbFont.SelectedIndex << 1);
                this.FontSize = fonzsize;
                bnClear.FontSize = fonzsize;
                labelSamples.FontSize = fonzsize;
                cbSamples.FontSize = fonzsize;
                bnInsertSample.FontSize = fonzsize;
                cbNumbers.FontSize = fonzsize;
                labelNumbers.FontSize = fonzsize;                
                cbFont.FontSize = fonzsize;

                bnStep.FontSize = fonzsize;
                bnTimer.FontSize = fonzsize;
                
            }
        }

        //<ComboBoxItem>10x10</ComboBoxItem>
        //                   <ComboBoxItem>30x10</ComboBoxItem>
        //                   <ComboBoxItem>40x20</ComboBoxItem>
        //                   <ComboBoxItem>60x30</ComboBoxItem>
        //                   <ComboBoxItem>80x40</ComboBoxItem>
        private void cbNumbers_SelectionChanged(Object sender, SelectionChangedEventArgs e) {
            if (!start) {
                firstStep = true;
                switch (cbNumbers.SelectedIndex) {
                    case 0:
                        createGrid(10, 10);
                        break;
                    case 1:
                        createGrid(30, 10);
                        break;
                    case 2:
                        createGrid(40, 20);
                        break;
                    case 3:
                        createGrid(60, 30);
                        break;
                    case 4:
                        createGrid(80, 40);
                        break;
                }
            }
        }

        private void bnClear_Click(Object sender, RoutedEventArgs e) {
            foreach (UIElement item in grid.Children) {
                ((ToggleButton)item).IsChecked = false;
            }
            firstStep = true;
        }





        private void createGrid(int cols, int rows) {
            grid.Children.Clear();
            grid.Rows = rows;
            grid.Columns = cols;
            this.cols = cols;
            this.rows = rows;
            cells = new ToggleButton[cols, rows];
            cells1 = new bool[cols, rows];
            cells2 = new bool[cols, rows];
            for (int row = 0; row < rows; row++) {
                for (int col=0; col<cols; col++) {
                    ToggleButton bn = new ToggleButton();
                    //bn.Content = col.ToString() + " / " + row;
                    bn.Click += bnToggle_Click;
                    grid.Children.Add(bn);
                    cells[col, row] = bn;
                    cells1[col, row] = false;
                    cells2[col, row] = false;
                }
            }
        }

        private void bnToggle_Click(Object sender, RoutedEventArgs e) {
            firstStep = true;
        }

        private void bnInsertSample_Click(Object sender, RoutedEventArgs e) {
            insertSamples();
        }


        // Action
        private void insertSamples() {
            bnClear_Click(null, null);
            int ofsx = 0;
            int ofsy = 0;
            firstStep = true;
            switch (cbSamples.SelectedIndex) {
                case 0:
                    // Hantel
                    cells[ofsx+4, 4+ofsy].IsChecked = true; // col /rows
                    cells[ofsx+5, 4+ofsy].IsChecked = true;
                    cells[ofsx+6, 4+ofsy].IsChecked = true;
                    cells[ofsx+5, 5+ofsy].IsChecked = true;
                    cells[ofsx+4, 6+ofsy].IsChecked = true;
                    cells[ofsx+5, 6+ofsy].IsChecked = true;
                    cells[ofsx+6, 6+ofsy].IsChecked = true;
                    break;
                case 1:
                    // Blinker
                    cells[ofsx+4, 5+ofsy].IsChecked = true;
                    cells[ofsx+5, 5+ofsy].IsChecked = true;
                    cells[ofsx+6, 5+ofsy].IsChecked = true;
                    break;
                case 2:
                    // Uhr
                    cells[ofsx+5, 3+ofsy].IsChecked = true;
                    cells[ofsx+3, 4+ofsy].IsChecked = true;
                    cells[ofsx+4, 4+ofsy].IsChecked = true;
                    cells[ofsx+5, 5+ofsy].IsChecked = true;
                    cells[ofsx+6, 5+ofsy].IsChecked = true;
                    cells[ofsx+4, 6+ofsy].IsChecked = true;
                    break;
                case 3:
                    // Kröte
                    cells[ofsx+5, 3+ofsy].IsChecked = true;
                    cells[ofsx+4, 3+ofsy].IsChecked = true;
                    cells[ofsx+3, 4+ofsy].IsChecked = true;

                    cells[ofsx+6, 5+ofsy].IsChecked = true;
                    cells[ofsx+4, 6+ofsy].IsChecked = true;
                    cells[ofsx+5, 6+ofsy].IsChecked = true;
                    break;
                case 4:
                    // Bipole
                    cells[ofsx+4, 3+ofsy].IsChecked = true;
                    cells[ofsx+5, 3+ofsy].IsChecked = true;
                    cells[ofsx+4, 4+ofsy].IsChecked = true;
                    cells[ofsx+7, 5+ofsy].IsChecked = true;
                    cells[ofsx+6, 6+ofsy].IsChecked = true;
                    cells[ofsx+7, 6+ofsy].IsChecked = true;
                    break;
                case 5:
                    // Pulsator
                    cells[ofsx+4, 3+ofsy].IsChecked = true;
                    cells[ofsx+5, 3+ofsy].IsChecked = true;
                    cells[ofsx+3, 4+ofsy].IsChecked = true;
                    cells[ofsx+6, 4+ofsy].IsChecked = true;

                    cells[ofsx+2, 5+ofsy].IsChecked = true;
                    cells[ofsx+3, 5+ofsy].IsChecked = true;
                    cells[ofsx+4, 5+ofsy].IsChecked = true;
                    cells[ofsx+5, 5+ofsy].IsChecked = true;
                    cells[ofsx+6, 5+ofsy].IsChecked = true;
                    cells[ofsx+7, 5+ofsy].IsChecked = true;

                    cells[ofsx+3, 6+ofsy].IsChecked = true;
                    cells[ofsx+6, 6+ofsy].IsChecked = true;
                    cells[ofsx+4, 7+ofsy].IsChecked = true;
                    cells[ofsx+5, 7+ofsy].IsChecked = true;
                    break;
                case 6:
                    // Tümmler
                    cells[ofsx+3, 2+ofsy].IsChecked = true;
                    cells[ofsx+2, 3+ofsy].IsChecked = true;
                    cells[ofsx+3, 3+ofsy].IsChecked = true;
                    cells[ofsx+2, 4+ofsy].IsChecked = true;

                    cells[ofsx+4, 4+ofsy].IsChecked = true;
                    cells[ofsx+4, 5+ofsy].IsChecked = true;
                    cells[ofsx + 4, 6 + ofsy].IsChecked = true;
                    cells[ofsx + 3, 6 + ofsy].IsChecked = true;
                    cells[ofsx + 3, 7 + ofsy].IsChecked = true;

                    cells[ofsx + 7, 2 + ofsy].IsChecked = true;
                    cells[ofsx + 7, 3 + ofsy].IsChecked = true;
                    cells[ofsx + 8, 3 + ofsy].IsChecked = true;
                    cells[ofsx + 8, 4 + ofsy].IsChecked = true;

                    cells[ofsx + 6, 4 + ofsy].IsChecked = true;
                    cells[ofsx + 6, 5 + ofsy].IsChecked = true;
                    cells[ofsx + 6, 6 + ofsy].IsChecked = true;
                    cells[ofsx + 7, 6 + ofsy].IsChecked = true;
                    cells[ofsx + 7, 7 + ofsy].IsChecked = true;
                    break;
                case 7:
                    // lightwidght spaceshiop
                    cells[ofsx + 3, 3 + ofsy].IsChecked = true;
                    cells[ofsx + 4, 3 + ofsy].IsChecked = true;

                    cells[ofsx + 1, 4 + ofsy].IsChecked = true;
                    cells[ofsx + 2, 4 + ofsy].IsChecked = true;
                    cells[ofsx + 4, 4 + ofsy].IsChecked = true;
                    cells[ofsx + 5, 4 + ofsy].IsChecked = true;

                    cells[ofsx + 1, 5 + ofsy].IsChecked = true;
                    cells[ofsx + 2, 5 + ofsy].IsChecked = true;
                    cells[ofsx + 3, 5 + ofsy].IsChecked = true;
                    cells[ofsx + 4, 5 + ofsy].IsChecked = true;

                    cells[ofsx + 2, 6 + ofsy].IsChecked = true;
                    cells[ofsx + 3, 6 + ofsy].IsChecked = true;

                    break;
                case 8:
                    // Gleiter
                    cells[ofsx + 2, 1 + ofsy].IsChecked = true;
                    cells[ofsx + 3, 2 + ofsy].IsChecked = true;

                    cells[ofsx + 1, 3 + ofsy].IsChecked = true;
                    cells[ofsx + 2, 3 + ofsy].IsChecked = true;
                    cells[ofsx + 3, 3 + ofsy].IsChecked = true;

                    break;
                case 9:
                    // Segler
                    cells[ofsx + 2, 3 + ofsy].IsChecked = true;
                    cells[ofsx + 3, 3 + ofsy].IsChecked = true;
                    cells[ofsx + 4, 3 + ofsy].IsChecked = true;
                    cells[ofsx + 5, 3 + ofsy].IsChecked = true;

                    cells[ofsx + 1, 4 + ofsy].IsChecked = true;
                    cells[ofsx + 5, 4 + ofsy].IsChecked = true;

                    cells[ofsx + 5, 5 + ofsy].IsChecked = true;

                    cells[ofsx + 1, 6 + ofsy].IsChecked = true;
                    cells[ofsx + 4, 6 + ofsy].IsChecked = true;

                    break;
            }
        }

        private void bnStep_Click(Object sender, RoutedEventArgs e) {
            if (firstStep) {
                // Baue cells1
                for (int row = 0; row < this.rows; row++) {
                    for (int col = 0; col < this.cols; col++) {
                        ToggleButton bn = cells[col, row];
                        if (bn.IsChecked==true) {
                            cells1[col, row] = true;
                        }
                        else {
                            cells1[col, row] = false;
                        }
                    }
                }
                firstStep = false;
            }
            int j = 0;
            for (int row = 0; row < this.rows; row++) {
                for (int col = 0; col < this.cols; col++) {
                    int n = getNeighbors(col, row);
                    if (n>0) { 
                        n = getNeighbors(col, row);
                    }
                    if (col == 4 && row == 5) {
                        j = 0;
                        n = getNeighbors(col, row);
                    }
                    if (col == 5 && row == 5) {
                        j = 0;
                    }
                    if (col == 6 && row == 5) {
                        j = 0;
                    }
                    if (cells1[col, row]) {
                        // zelle hat leben
                        if (n == 2 || n == 3) {
                            cells2[col, row] = true;  // bleibt
                        }
                        else {
                            cells2[col, row] = false;
                        }

                    }
                    else {
                        // zelle hat kein leben
                        if (n==3) {
                            cells2[col, row] = true;  // Geburt !
                        }
                        else {
                            cells2[col, row] = false;
                        }
                    }
                }
            } // for

            // nun kopieren
            for (int row = 0; row < this.rows; row++) {
                for (int col = 0; col < this.cols; col++) {
                    cells1[col, row] = cells2[col, row];
                    if (cells1[col, row])
                        cells[col, row].IsChecked = true;
                    else
                        cells[col, row].IsChecked = false;
                }
            }
        }  // bnStep_Click

        private int getNeighbors(int col, int row) {
            int n = 0;
            int[] neighborsplaces = { -1, 0, +1 };
            for (int r = 0; r < neighborsplaces.Length; r++) {
                for (int c = 0; c < neighborsplaces.Length; c++) {
                    int cc = col + neighborsplaces[c];
                    int rr = row + neighborsplaces[r];
                    if (cc>=0 && rr>0 && cc< this.cols  && rr<this.rows  && (c != 1 || r != 1)) {
                        if (cells1[cc, rr] == true) {
                            n++;
                        }
                    }
                }
            }
            return n;
        }

        private void bnTimer_Click(Object sender, RoutedEventArgs e) {

        }


        private void Window_Closing(Object sender, System.ComponentModel.CancelEventArgs e) {
            Basis.writeWindowPosition2Registry(this, C_REG_ADR, windowname);
        }

    }
}
