unit Main;

//Titel:         Huffmann Code
//Version:       1.0, 24.01.2006
//Copyright:     Copyright (c) 2006
//Autor:         Dipl.-Inf., Dipl.-Ing. (FH) Michael Wilhelm
//Organisation:  HS Harz, FB AI
//Beschreibung:  Erzeugt Dateien zum Testen von ZIP-Programmen
//               Analyse der Daten beim ffnen
//               Die Programmieren ist bewusst sehr einfach gehalten

// Zip-Verfahren:Deflate, Deflate64 , Reduced, Run Length Encoding (RLE)
// Info:         http://www.binaryessence.de/


interface

// Welche Units mssen eingebunden werden
uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls, ComCtrls, Menus;

const MAXCHARS = 255;
const MAX = 5010;// Feldgre fr doppelte


type pHufmann = ^THufmann;

     THufmann = record
               a:pHufmann;
               b:pHufmann;
               value:integer;
               name:char;
               Anzahl:integer;
end;


// Klassendefinition  
type
  TFMain = class(TForm)
    Panel1: TPanel; // Obere Leiste
    BnOpen: TBitBtn;
    BnZIP_Programm: TBitBtn;
    OpenDialog1: TOpenDialog;
    MainTab: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Memo1: TMemo;
    Memo2: TMemo;
    Label2: TLabel;
    cbFontsize: TComboBox;
    MainMenu1: TMainMenu;
    MainDatei: TMenuItem;
    MnDatenbankOeffnen: TMenuItem;
    N6: TMenuItem;
    MnBeenden: TMenuItem;
    MainBearbeiten: TMenuItem;
    MnUndo: TMenuItem;
    N5: TMenuItem;
    MnCut: TMenuItem;
    MnCopy: TMenuItem;
    MnInsert: TMenuItem;
    N3: TMenuItem;
    MnAllesmarkieren: TMenuItem;
    MainHilfe: TMenuItem;
    MnProgInfo: TMenuItem;
    Erzeugen1: TMenuItem;
    ErzeugenderBeispieldateien1: TMenuItem;
    TabSheet3: TTabSheet;
    Memo3: TMemo;
    Dateispeichernunter1: TMenuItem;
    SaveDialog1: TSaveDialog;
    N1: TMenuItem;
    MnSaveFile: TMenuItem;
    Panel_FileName: TPanel;
    BnSave: TSpeedButton;  // Editor
      // Methoden der Klasse
    procedure BnOpenClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BnZIP_ProgrammClick(Sender: TObject);
    procedure cbFontsizeChange(Sender: TObject);
    procedure MnProgInfoClick(Sender: TObject);
    procedure MnBeendenClick(Sender: TObject);
    procedure ErzeugenderBeispieldateien1Click(Sender: TObject);
    procedure MnUndoClick(Sender: TObject);
    procedure MnCutClick(Sender: TObject);
    procedure MnCopyClick(Sender: TObject);
    procedure MnInsertClick(Sender: TObject);
    procedure MnAllesmarkierenClick(Sender: TObject);
    procedure Dateispeichernunter1Click(Sender: TObject);
    procedure MainDateiClick(Sender: TObject);
    procedure MnSaveFileClick(Sender: TObject);
    procedure BnSaveClick(Sender: TObject);
    procedure MnDatenbankOeffnenClick(Sender: TObject);
  private
    { Private-Deklarationen }
    _Pfad:string;
    _sFilename:string;
    _sFilenameNeu:string;

      // speichert die Anzahl der Buchstaben
    _Anz1:array[0..MAXCHARS] of integer;  // wir haben nur 5 Zeichen
      // speichert, wie oft ein Zeichen mit Wiederholung vorkommt
      // wie oft A, wie oft AA, wie oft AAA etc.
    _Anz2:array[0..MAXCHARS,0..MAX] of integer;

    _huffm: array[0..MAXCHARS] of THufmann;

    _Summe:integer;
    _SummeNormal:integer;

    _bStart:boolean;

    procedure Analyze(sFilename:String);
    procedure Extract(node:THufmann; sNr:string);
  public
    { Public-Deklarationen }
  end;

var
  FMain: TFMain;

implementation

{$R *.dfm}

uses basis, Start, shellapi;

   // Pfade
const C_Archiv = 'C:\Programme\PowerArchiver\POWERARC.EXE';

  // Zeichenumbruch
Const NL = chr(13)+chr(10);

// Hilfsfunktionen
procedure Fehler(szTitel,szText:string);
begin
  // WinTypes
  Application.MessageBox(PChar(szText),PChar(szTitel), MB_IconStop+mb_OK);
end;

// Hilfsfunktionen, Ausfhren eines Programms
function ExecuteFile(const FileName, Params, DefaultDir: string; ShowCmd: Integer): THandle;
var szExt:string;
begin
  Result := ShellExecute(Application.MainForm.Handle, 'open',
    PChar(FileName), PChar(Params),
    PChar(DefaultDir), ShowCmd);
  if Result<=32 then
  begin
    case Result of
      0: Fehler('Fehler','Fehler beim Aufruf der Datei/des Programms'+NL+FileName+NL+'Zu wenig Speicher');
      ERROR_FILE_NOT_FOUND:
        begin
          szExt := Uppercase(ExtractFileExt(Filename));
          if (szExt='.EXE') or (szExt='.COM') then
          Fehler('Fehler','Fehler beim Aufruf der Datei/des Programms'+NL+FileName+NL+'Das Programm existiert nicht');
        end;
      SE_ERR_NOASSOC:
        Fehler('Fehler','Fehler beim Aufruf der Datei/des Programms'+NL+FileName+NL+'Fr diese Datei existiert keine Verknpfung');

      ERROR_PATH_NOT_FOUND:
        Fehler('Fehler','Fehler beim Aufruf der Datei/des Programms'+NL+FileName+NL+'Der Pfad wurde nicht gefunden');
      ERROR_BAD_FORMAT:
        Fehler('Fehler','Fehler beim Aufruf der Datei/des Programms'+NL+FileName+NL+'Das Programm ist fehlerhaft');
      SE_ERR_ACCESSDENIED:
        Fehler('Fehler','Fehler beim Aufruf der Datei/des Programms'+NL+FileName+NL+'Auf das Programm konnte nicht zugegriffen werden. Zugriffsverweigerung');
      SE_ERR_ASSOCINCOMPLETE:
        Fehler('Fehler','Fehler beim Aufruf der Datei/des Programms'+NL+FileName+NL+'Die Dateizuordnung ist fehlerhaft oder nicht vorhanden');
      SE_ERR_DDEFAIL,
      SE_ERR_DDETIMEOUT,
      SE_ERR_DDEBUSY:
        Fehler('Fehler','Fehler beim Aufruf der Datei/des Programms'+NL+FileName+NL+'DDE Fehler');
      SE_ERR_DLLNOTFOUND:
        Fehler('Fehler','Fehler beim Aufruf der Datei/des Programms'+NL+FileName+NL+'Die DLL konnte nicht gefunden werden');
      SE_ERR_OOM:
        Fehler('Fehler','Fehler beim Aufruf der Datei/des Programms'+NL+FileName+NL+'Zu wenig Speicher');
      SE_ERR_SHARE:
        Fehler('Fehler','Fehler beim Aufruf der Datei/des Programms'+NL+FileName+NL+'Zugriff verweigert. A sharing violation occurred.');
     else  Fehler('Fehler','Fehler beim Aufruf der Datei/des Programms'+NL+FileName);
    end;
  end;
end;


// Hilfsfunktionen, Ausgabe einer Meldung
procedure Meldung(szTitel,szText:string);
begin
  Application.MessageBox(PChar(szText),PChar(szTitel), MB_iconExclamation+mb_OK);
end;

// Hilfsfunktionen, Am Anfang muss immer ein BackSlash stehen
function AddBackSlash(szPfad:string):string;
var n:integer;
begin
  n := Length(szPfad);
  If copy(szPfad,n,1) <> '\'
  Then result := szPfad+'\'
  else result:= szPfad;
end;


// Wird beim Erzeugen des Fensters aufgerufen
procedure TFMain.FormCreate(Sender: TObject);
begin
_sFilenameNeu:='';

        // setzen des aktuellen Pfades
 _Pfad :=  ExtractFilepath(Application.ExeName);
 _Pfad :=  AddBackSlash(_Pfad);
 Memo1.align := alClient;  // Editor erhlt die komplette Flche
 Memo1.Clear;  // Lschen des Editors
 MainTab.align := alClient;  // Editor erhlt die komplette Flche
 MainTab.ActivePageIndex:=0;
 Memo2.align := alClient;  // Editor erhlt die komplette Flche
 Memo2.Clear;  // Lschen des Editors
 Memo3.align := alClient;  // Editor erhlt die komplette Flche
 Memo3.Clear;  // Lschen des Editors
 _bStart:=true;
   cbFontsize.Clear();
   with cbFontsize do
   begin
     Items.add('6');
     Items.add('8');
     Items.add('10');
     Items.add('11');
     Items.add('12');
     Items.add('13');
     Items.add('14');
     Items.add('15');
     Items.add('16');
     Items.add('18');
     Items.add('20');
     Items.add('22');
     Items.add('24');
     Items.add('26');
     Items.add('30');
     Items.add('32');
     Items.add('34');
     Items.add('36');
     Items.add('38');
     Items.add('40');
   end;
  _bStart := false;
end;


// Aufruf beim Klick auf den Schalter
procedure TFMain.MnDatenbankOeffnenClick(Sender: TObject);
begin
  BnOpenClick(Sender);
end;

procedure TFMain.BnOpenClick(Sender: TObject);
begin
  OpenDialog1.Title := 'Datenbank-Projekte ffnen';

  OpenDialog1.InitialDir := _Pfad;
  OpenDialog1.FileName:= '*.HFM';
  OpenDialog1.DefaultExt := '.HFM';
  OpenDialog1.Options :=  [ofEnableSizing, ofPathMustExist,ofShowHelp];
  OpenDialog1.Filter := 'Hufmann Testdateien *.HFM|*.HFM|Alle Dateien *.*|*.*|';

  if OpenDialog1.Execute then
  begin
    Analyze(OpenDialog1.FileName);
  end;
end;



// liest den Text ein und analysiert ihn
procedure TFMain.Analyze(sFilename:String);
var kanal:file of char;// zum Datei lesen
    i:integer;
    j, k, sum, oldChar:integer;
    hh:THufmann;
    pH1, pH2:pHufmann;
    IndexHufmann, AnzHuffman:integer;
    Summe:integer;
    ch:char;
    Summen_bytes:integer;
begin
  _sFilename := sFilename;
  Caption := _sFilename;
  
 Memo1.Clear;

 Memo2.Lines.LoadFromFile(sFilename);

 memo1.Lines.add(sFilename);
 memo1.Lines.add('');

 assignfile(kanal,sFilename);// ffnen
 reset(kanal);

 // Init
 for i:=0 to MAXCHARS do _Anz1[i]:=0;
 for i:=0 to MAXCHARS do
 begin
   for j:=0 to MAX do _Anz2[i,j]:=0;
 end;

 oldChar := -1;
 sum:=0;
 while not eof(kanal) do
 begin
   read(kanal,ch);  // Einlesen eines Zeichens
   k := ord(ch);  // neue Zeichen, A=65
   if (k<33) then continue;

         // 1. Code fr einfaches Aufaddieren
   inc(_Anz1[k],1);  // nur ein Zeichen

         // 2. Code fr Wiederholungen
   if oldChar=-1 then
   begin  // 1. Zeichen
     oldChar := k;
     sum:=1;
   end
   else
   begin
     if oldChar<>k then
     begin
       // anderes Zeichen
       inc( _Anz2[oldChar,sum], 1);
       oldChar:=k;
       sum:=1;
     end
     else
     begin
       // identisches Zeichen
       inc(sum,1);
     end;
   end;
 end;
 closefile(kanal);  // Schlieen des Kanals zur Datei



   // gab es noch einen Rest ?
 inc( _Anz2[oldChar,sum],1);

     // einfache Ausgabe 1.Code
 _SummeNormal:=0;
 for i:=0 to MAXCHARS do
 begin
        // Umwandlung von Integerzahl zum Text IntTostr(123);
   if _Anz1[i]>0 then
   begin
     Memo1.lines.add( 'Zeichen: '+char(i)+ '  Anzahl: '+IntTostr(_Anz1[i]) );
     inc(_SummeNormal,_Anz1[i]);
   end;
 end;
 Memo1.lines.add( '' );

 // Hufmann Berechnung
 for i:=0 to MAXCHARS do
 begin
      _huffm[i].a := nil;
      _huffm[i].b := nil;
      _huffm[i].value := 0;
      _huffm[i].name := 'X';  // i+65
      _huffm[i].Anzahl := 0;
 end;

 AnzHuffman:=0;
 for i:=0 to MAXCHARS do
 begin
    if _Anz1[i]>0 then
    begin
      inc(AnzHuffman,1);
      _huffm[AnzHuffman-1].a := nil;
      _huffm[AnzHuffman-1].b := nil;
      _huffm[AnzHuffman-1].value := _Anz1[i];
      _huffm[AnzHuffman-1].name := char(i);  // i+65
      _huffm[AnzHuffman-1].Anzahl := _Anz1[i];
    end;
 end;

 _Summe := 0;
 IndexHufmann:=0;
 while AnzHuffman>2 do
 begin
   // sortieren, hier aber umgekehrt
   repeat
     j:=0;
     for i:=0 to AnzHuffman-2 do
     begin
       if _huffm[i].value < _huffm[i+1].value then
       begin
         hh         := _huffm[i];
         _huffm[i]   := _huffm[i+1];
         _huffm[i+1] := hh;
         j:=1;
       end;
     end; // for
   until j=0;
     // Zusammenfassen
   new(pH1);
   new(pH2);
   pH2^ := _huffm[AnzHuffman-2];
   pH1^ := _huffm[AnzHuffman-1];  // kleinste
   _huffm[AnzHuffman-2].a :=pH1;
   _huffm[AnzHuffman-2].b :=pH2;
   _huffm[AnzHuffman-2].value := pH1.value + pH2.value;
   inc(IndexHufmann,1);
   _huffm[AnzHuffman-2].Name := char(119+IndexHufmann);
   _huffm[AnzHuffman-1].value:=0;
   //_huffm[AnzHuffman-1].name:=#0;
   _huffm[AnzHuffman-1].Name := char(120+IndexHufmann);
   _huffm[AnzHuffman-1].a:=nil;
   _huffm[AnzHuffman-1].b:=nil;
   dec(AnzHuffman,1);
 end;
   // nun noch eventuell das letzte tauschen
 if _huffm[0].value < _huffm[1].value then
 begin
   hh         := _huffm[0];
   _huffm[0]   := _huffm[1];
   _huffm[1] := hh;
 end;

// Memo1.lines.add( '' );
// Memo1.lines.add( '' );
// Memo1.lines.add( 'Code-Lnge' );

(* for i:=0 to 4 do
 begin
        // Umwandlung von Integerzahl zum Text IntTostr(123);
   Memo1.lines.add( 'Zeichen '+char(i+65)+ '  '+IntTostr(Anz1[i]) );
 end;
  *)
 Memo1.lines.add( '' );
 Memo1.lines.add( 'Hufmann-Code' );
 Memo1.lines.add( '' );

   Extract(_huffm[0],'1');
   if _huffm[1].Anzahl>0 then Extract(_huffm[1],'0');

 Memo1.lines.add( ' ' );
 Memo1.lines.add( 'Gesamtsumme in Bits :  '+IntToStr(_Summe)  );
 Summen_bytes := _Summe div 8;
 if (_Summe mod 8)>0 then inc(Summen_bytes,1);
 Memo1.lines.add( 'Gesamtsumme in Bytes:  '+IntToStr( Summen_bytes )  );
 Memo1.lines.add( 'Unkomprimiert  Bytes:  '+IntToStr( _SummeNormal ) );

 Memo1.lines.add( ' ' );
 Memo1.lines.add( ' ' );
 Memo1.lines.add( 'Ausgabe der Mehrfachsequenz (AA bis AAAAA) ' );
     // komplexe Ausgabe 2.Code
 for i:=0 to MAXCHARS do
   for j:=0 to MAX do
   begin
     sum := _Anz2[i,j];
     if sum>0 then
     begin
       Memo1.lines.add( 'Zeichen '+char(i)+
           '  Lnge: '+IntTostr(j)+ '    Anzahl:'+IntTostr(sum) );
     end;
 end;
end;  // Analyze


procedure TFMain.Extract(node:THufmann; sNr:string);
var AnzB:integer;
begin
 if (node.a=nil) and (node.b=nil) then
 begin
   AnzB := node.Anzahl * length(sNr);
  _Summe := _Summe + AnzB;
     // Ende
   Memo1.lines.add( 'Zeichen '+node.name+'  Code: '+sNr+
      '  Anzahl: '+IntToStr(node.Anzahl ) +'    SummeBytes: '+IntToStr(AnzB)  );
 end
 else
 begin
   Extract(node.a^,sNr+'0');
   Extract(node.b^,sNr+'1');
 end;
end;

(*
Zeichen A  2904    1
Zeichen B  1081    01
Zeichen C  638    001
Zeichen D  89    0000
Zeichen E  288   0001

*)

procedure TFMain.ErzeugenderBeispieldateien1Click(Sender: TObject);
var kanal:file of char; // Variable fr die Datei
    k, i, j:integer;
    ch:char;

    procedure ChWrite(ch:char);
    begin
       write(kanal, ch );
    end;
begin
  // ffnen zum Schreiben, Datei wird IMMER berschrieben
 assignfile(kanal,_Pfad+'Huffman1.HFM');
 rewrite(kanal);
 randomize(); // Init des Zufallsgenerator

 ChWrite(  'E' );
 ChWrite(  'A' );
 ChWrite(  'A' );
 ChWrite(  'B' );
 ChWrite(  'B' );
 ChWrite(  'B' );
 ChWrite(  'A' );
 ChWrite(  'A' );
 ChWrite(  'A' );
 ChWrite(  'B' );
 ChWrite(  'E' );
 ChWrite(  'C' );
 ChWrite(  'C' );
 ChWrite(  'C' );
 ChWrite(  'D' );
 ChWrite(  'C' );
 ChWrite(  'A' );
 ChWrite(  'A' );
 ChWrite(  'D' );
 ChWrite(  'C' );
 ChWrite(  'D' );
 ChWrite(  'C' );
 closefile(kanal);


        // Diese Variante dient zum Testen eines Algorithmus
 assignfile(kanal,_Pfad+'Huffman2.HFM');
 rewrite(kanal);
 ch := 'A';  write(kanal,  ch  );
 ch := 'A';  write(kanal,  ch  );
 ch := 'A';  write(kanal,  ch  );
 ch := 'B';  write(kanal,  ch  );
 ch := 'B';  write(kanal,  ch  );
 ch := 'C';  write(kanal,  ch  );
 ch := 'C';  write(kanal,  ch  );
 ch := 'D';  write(kanal,  ch  );
 ch := 'A';  write(kanal,  ch  );
 ch := 'B';  write(kanal,  ch  );
 ch := 'B';  write(kanal,  ch  );
 ch := 'C';  write(kanal,  ch  );
 ch := 'C';  write(kanal,  ch  );
 ch := 'D';  write(kanal,  ch  );
 ch := 'D';  write(kanal,  ch  );

 ch := 'A';  write(kanal,  ch  );
 ch := 'A';  write(kanal,  ch  );
 ch := 'A';  write(kanal,  ch  );

 ch := 'B';  write(kanal,  ch  );
 ch := 'B';  write(kanal,  ch  );

 ch := 'D';  write(kanal,  ch  );
 ch := 'D';  write(kanal,  ch  );
 ch := 'A';  write(kanal,  ch  );
 ch := 'D';  write(kanal,  ch  );
 ch := 'D';  write(kanal,  ch  );
 ch := 'E';  write(kanal,  ch  );
 ch := 'A';  write(kanal,  ch  );
 ch := 'D';  write(kanal,  ch  );
 ch := 'D';  write(kanal,  ch  );
 ch := 'E';  write(kanal,  ch  );
 closefile(kanal);


 

  // ffnen zum Schreiben, Datei wird IMMER berschrieben
 assignfile(kanal,_Pfad+'Huffman3.HFM');
 rewrite(kanal);
 randomize(); // Init des Zufallsgenerator

 for i:=1 to 5000 do
 begin
   j := random(50)+1;
   ch := 'A';
   if (j<=29) then ch := 'A';
   if (j>=30) then ch := 'B';
   if (j>=41) then ch := 'C';
   if (j>=47) then ch := 'D';
   if (j>=48) then ch := 'E';
   write(kanal,  ch );  // Schreiben eines Zeichens
 end;
 closefile(kanal);





  // ffnen zum Schreiben, Datei wird IMMER berschrieben
  // Alle relativ gleichmig
 assignfile(kanal,_Pfad+'Huffman4.HFM');
 rewrite(kanal);
 randomize(); // Init des Zufallsgenerator

 for i:=1 to 5000 do
 begin
   j := random(50)+1;
   ch := 'A';
   if (j<=10) then ch := 'A';
   if (j>=11) then ch := 'B';
   if (j>=21) then ch := 'C';
   if (j>=31) then ch := 'D';
   if (j>=41) then ch := 'E';
   write(kanal,  ch );  // Schreiben eines Zeichens
 end;
 closefile(kanal);



   // Diese Varianten schreibt mehrere Daten hintereinander
 assignfile(kanal,_Pfad+'Huffman5.HFM');
 rewrite(kanal);
 randomize();
 i:=1;
 while i<5000 do
 begin
   j := random(50)+1;
   ch := 'A';
   if (j<=29) then
   begin
     ch :=  'A';
     for k:= 1 to 3 do write(kanal, ch );
     inc(i,3);
   end;
   if (j>=30) then
   begin
     ch :=  'B';
     for k:= 1 to 3 do write(kanal, ch );
     inc(i,3);
   end;
   if (j>=41) then
   begin
     ch :=  'C';
     for k:= 1 to 3 do write(kanal, ch );
     inc(i,3);
   end;
   if (j>=47) then
   begin
     ch :=  'D';
     for k:= 1 to 2 do write(kanal, ch );
     inc(i,2);
   end;
   if (j>=48) then
   begin
     ch :=  'E';
     for k:= 1 to 1 do write(kanal, ch );
     inc(i,1);
   end;
 end;
 closefile(kanal);


  // Diese Variante schreibt Blcke aller Zeichen
  // Optimal frs Run Length Encoding
 assignfile(kanal,_Pfad+'Huffman6.HFM');
 rewrite(kanal);
 for i:=1 to 5000 do
 begin
   ch := 'A';
   if (i<=2900) then ch := 'A';
   if (i>=3000) then ch := 'B';
   if (i>=4100) then ch := 'C';
   if (i>=4700) then ch := 'D';
   if (i>=4800) then ch := 'E';
   write(kanal,  ch );
 end;
 closefile(kanal);


  // Diese Variante schreibt nur ein Zeichen, das A
  // Optimal frs Run Length Encoding
  // 1,94%  
 assignfile(kanal,_Pfad+'Huffman7.HFM');
 rewrite(kanal);
 ch := 'A';
 for i:=1 to 5000 do
 begin
   write(kanal,  ch );
 end;
 closefile(kanal);


 Meldung('Huffman Dateien schreiben','Die Dateien wurden erzeugt');
//
end;



procedure TFMain.BnZIP_ProgrammClick(Sender: TObject);
begin
// if _sFilename<>'' then
 begin
  ExecuteFile(C_Archiv, _sFilename,'', SW_SHOW);
 end;

end;

procedure TFMain.cbFontsizeChange(Sender: TObject);
var s:string;
    size:integer;
begin
  if _bStart then exit;
  (*
  i := cbFontsize.ItemIndex;
  if i<0 then exit;
  *)
  s := cbFontsize.Text;
  if IVal(s,size) then
  begin
    Memo1.Font.Size := size;
    Memo2.Font.Size := size;
    Memo3.Font.Size := size;
    Panel_FileName.Font.Size := size;
  end;

end;

procedure TFMain.MnProgInfoClick(Sender: TObject);
var F:TFStart;
begin
  f := TFStart.Create(Application);
  try
    f.init;
  finally
    f.Free;
  end;
end;

procedure TFMain.MnBeendenClick(Sender: TObject);
begin
  close;
end;


procedure TFMain.MnUndoClick(Sender: TObject);
begin
  case MainTab.ActivePageIndex of
  0: Memo1.Undo();
  1: Memo2.Undo();
  2: Memo3.Undo();
  end;
end;

procedure TFMain.MnCutClick(Sender: TObject);
begin
  case MainTab.ActivePageIndex of
   0: Memo1.CutToClipboard();
   1: Memo2.CutToClipboard();
   2: Memo3.CutToClipboard();
  end;
end;

procedure TFMain.MnCopyClick(Sender: TObject);
begin
  case MainTab.ActivePageIndex of
  0: Memo1.CopyToClipboard();
  1: Memo2.CopyToClipboard();
  2: Memo3.CopyToClipboard();
  end;
end;

procedure TFMain.MnInsertClick(Sender: TObject);
begin
  case MainTab.ActivePageIndex of
   0: Memo1.PasteFromClipboard();
   1: Memo2.PasteFromClipboard();
   2: Memo3.PasteFromClipboard();
  end;
end;

procedure TFMain.MnAllesmarkierenClick(Sender: TObject);
begin
  case MainTab.ActivePageIndex of
   0: Memo1.SelectAll();
   1: Memo2.SelectAll();
   2: Memo3.SelectAll();
  end;
end;

procedure TFMain.BnSaveClick(Sender: TObject);
begin
  case MainTab.ActivePageIndex of
   0: Dateispeichernunter1Click(Sender);
   1: Dateispeichernunter1Click(Sender);
   2: begin
        if _sFilenameNeu<>''
        then MnSaveFileClick(Sender)
        else Dateispeichernunter1Click(Sender);
      end;
   end;
end;

procedure TFMain.MnSaveFileClick(Sender: TObject);
begin
  BnSaveClick(Sender);
end;

procedure TFMain.Dateispeichernunter1Click(Sender: TObject);
begin
  SaveDialog1.Title := 'Datei speichern unter';

  // SaveDialog1.FileName:= szUFiltermaske;
  SaveDialog1.Filter := '*.HFM';
  SaveDialog1.InitialDir := G_Pfad;

  SaveDialog1.Filename := '';

  if SaveDialog1.Execute then
  begin
    _sFilenameNeu := SaveDialog1.Filename;
    case MainTab.ActivePageIndex of
     0: Memo1.Lines.SaveToFile(_sFilenameNeu);
     1: Memo2.Lines.SaveToFile(_sFilenameNeu);
     2: begin
          Memo3.Lines.SaveToFile(_sFilenameNeu);
          Panel_FileName.Caption := _sFilenameNeu;
        end;
     end;
  end;
end;

procedure TFMain.MainDateiClick(Sender: TObject);
begin
  MnSaveFile.Enabled := _sFilenameNeu<>'';
end;




end.


dout.writeByte
