﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace LaGrange {
    /// <summary>
    /// Interaction logic for FInputPoint.xaml
    /// </summary>
    public partial class FInputPoint : Window {

        private string C_REG_ADR = "SOFTWARE\\WILHELM\\LAGRANGE";

        private String dbtable = "FInputPoint";

        private bool retcode = false;
        public bool Retcode {
            get { return retcode; }
        }

        public PointXY point = new PointXY(0,0);



        public FInputPoint(Window owner) {
            InitializeComponent();

            Basis.setWindowPositionFromRegistryWidthHeight(this, C_REG_ADR + "\\position", "dialog" + dbtable);
            this.Owner = owner;  // Important, because CenterOwner           
            this.WindowStartupLocation = WindowStartupLocation.CenterOwner;
        }

        private void Window_Loaded(object sender, RoutedEventArgs e) {
            tX.Focus();
        }

        private void bnOk_Click(object sender, RoutedEventArgs e) {
            decimal x, y;
            if (tX.Text.Trim().Length == 0) {
                Basis.ErrorMsg("Geben Sie bitte einen X-Wert ein", "Hinweis");
                tX.Focus();
                return;
            }
            if (tY.Text.Trim().Length == 0) {
                Basis.ErrorMsg("Geben Sie bitte einen Y-Wert ein", "Hinweis");
                tY.Focus();
                return;
            }
            if (!Check.tryDecimalPosNeg(tX.Text.Trim(), out x)) {
                Basis.ErrorMsg("Geben Sie bitte einen gültigen X-Wert ein", "Hinweis");
                tX.Focus();
                return;
            }
            if (!Check.tryDecimalPosNeg(tY.Text.Trim(), out y)) {
                Basis.ErrorMsg("Geben Sie bitte einen gültigen Y-Wert ein", "Hinweis");
                tX.Focus();
                return;
            }
            point.X = x;
            point.Y = y;
            retcode = true;
            Close();
        }

        private void bnEsc_Click(object sender, RoutedEventArgs e) {
            Close();
        }

        private void Window_KeyDown(object sender, KeyEventArgs e) {
            if (Keyboard.IsKeyDown(Key.Return)) {
                e.Handled = true;
                bnOk_Click(sender, e);
            }
            if (Keyboard.IsKeyDown(Key.Cancel)) {
                e.Handled = true;
                bnEsc_Click(sender, e);
            }
        }

        private void Window_Closing(object sender, System.ComponentModel.CancelEventArgs e) {
            e.Cancel = false;
            Basis.writeWindowPosition2Registry(this, C_REG_ADR + "\\position", "dialog" + dbtable);
        }

        private void tTextBox_GotFocus(Object sender, RoutedEventArgs e) {
            TextBox t = (TextBox)sender;
            t.SelectAll();
        }
    }
}
