﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using static LaGrange.XYGraphic;

namespace LaGrange {
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window {

        private String dbtable = "LAGRANGEMAIN";

        private string C_REG_ADR = "SOFTWARE\\WILHELM\\LAGRANGE";

        private List<PointXY> listePoints = new List<PointXY>();

        private XYGraphic graph1 = null;
        private XYGraphic graph2 = null;

        private Polynom polynomY = new Polynom();

        private bool start = true;

        private bool newton = false;


        public MainWindow() {
            InitializeComponent();
        }

        private void Window_Loaded(Object sender, RoutedEventArgs e) {

            datagrid.IsReadOnly = true;
            datagrid.CanUserAddRows = false;
            datagrid.CanUserDeleteRows = false;
            datagrid.CanUserResizeColumns = true;
            datagrid.CanUserSortColumns = true;

            datagrid.ItemsSource = listePoints;

            graph1 = new XYGraphic(this);
            graph2 = new XYGraphic(this);
            graphicPanel1.Children.Add(graph1);
            graphicPanel2.Children.Add(graph2);

            cbDrawMode1.SelectedIndex = 1;

            Basis.setWindowPositionFromRegistry(this, C_REG_ADR + "\\position", "table" + dbtable);
            start = false;
        }


        private void bnClearpoints_Click(Object sender, RoutedEventArgs e) {
            newton = false;
            listePoints.Clear();
            datagrid.ItemsSource = null;
            datagrid.ItemsSource = listePoints;
            grafik1();
        }


        private void bnAddpoint_Click(Object sender, RoutedEventArgs e) {
            newton = false;
            FInputPoint dialog = new FInputPoint(this);
            dialog.ShowDialog();
            if (dialog.Retcode) {
                listePoints.Add(new PointXY(dialog.point.X, dialog.point.Y));
                listePoints.Sort();
                datagrid.ItemsSource = null;
                datagrid.ItemsSource = listePoints;
                grafik1();
            }
        }

        private void bnDeletepoint_Click(Object sender, RoutedEventArgs e) {
            if (datagrid.SelectedIndex>=0) {
                listePoints.RemoveAt(datagrid.SelectedIndex);
                datagrid.ItemsSource = null;
                datagrid.ItemsSource = listePoints;
                grafik1();
                newton = false;
            }
        }


        private void LkBeispielScript1_Click(Object sender, RoutedEventArgs e) {
            newton = false;
            listePoints.Clear();
            listePoints.Add(new PointXY(-1, 3));
            listePoints.Add(new PointXY(0, 1));
            listePoints.Add(new PointXY(1, 4));
            
            datagrid.ItemsSource = null;
            datagrid.ItemsSource = listePoints;
            grafik1();
        }
        private void LkBeispielScript2_Click(Object sender, RoutedEventArgs e) {
            newton = false;
            listePoints.Clear();
            listePoints.Add(new PointXY(-1, 3));
            listePoints.Add(new PointXY(0, 1));
            listePoints.Add(new PointXY(1, 4));
            listePoints.Add(new PointXY(2, 3));
            listePoints.Add(new PointXY(3, 6));
            listePoints.Add(new PointXY(4, -2));
            listePoints.Add(new PointXY(5, 1));

            datagrid.ItemsSource = null;
            datagrid.ItemsSource = listePoints;
            grafik1();
        }

        private void LkBeispielScript3Papula_Click(Object sender, RoutedEventArgs e) {
            newton = false;
            listePoints.Clear();
            listePoints.Add(new PointXY(0, 12));
            listePoints.Add(new PointXY(2, -16));
            listePoints.Add(new PointXY(5, -28));
            listePoints.Add(new PointXY(7, 54));
            
            datagrid.ItemsSource = null;
            datagrid.ItemsSource = listePoints;
            grafik1();
        }

        private void LkBeispiel4_Click(Object sender, RoutedEventArgs e) {
            newton = false;
            listePoints.Clear();
            listePoints.Add(new PointXY(0, 1));
            listePoints.Add(new PointXY(1, 3));
            listePoints.Add(new PointXY(3, 2));

            datagrid.ItemsSource = null;
            datagrid.ItemsSource = listePoints;
            grafik1();
        }

        // wilhelm
        private void LkBeispiel5_Click(Object sender, RoutedEventArgs e) {
            newton = false;
            listePoints.Clear();
            listePoints.Add(new PointXY(1, 2));
            listePoints.Add(new PointXY(2, 3));
            listePoints.Add(new PointXY(3, 1));
            listePoints.Add(new PointXY(4, 3));

            datagrid.ItemsSource = null;
            datagrid.ItemsSource = listePoints;
            grafik1();
        }

        // Göttingen
        private void LkBeispiel6_Click(Object sender, RoutedEventArgs e) {
            newton = false;
            listePoints.Clear();
            listePoints.Add(new PointXY(1, 1));
            listePoints.Add(new PointXY(2, 8));
            listePoints.Add(new PointXY(3, 3));
            listePoints.Add(new PointXY(4, 3));
            listePoints.Add(new PointXY(5, 5));
            listePoints.Add(new PointXY(6, 3));
            listePoints.Add(new PointXY(7, 9));
            listePoints.Add(new PointXY(8, 7));
            listePoints.Add(new PointXY(9, 7));
            listePoints.Add(new PointXY(10, 9));

            datagrid.ItemsSource = null;
            datagrid.ItemsSource = listePoints;
            grafik1();
        }

        private void LkBeispiel7_Click(Object sender, RoutedEventArgs e) {
            newton = false;
            listePoints.Clear();
            listePoints.Add(new PointXY(-2.5m, 2));
            listePoints.Add(new PointXY(-1, -2));
            listePoints.Add(new PointXY(0.5m, -1.5m));
            listePoints.Add(new PointXY(1, 3));
            listePoints.Add(new PointXY(4, 2));

            datagrid.ItemsSource = null;
            datagrid.ItemsSource = listePoints;
            grafik1();
        }

        // Newton
        private void LkBeispiel8_Click(Object sender, RoutedEventArgs e) {
            newton = true;
            listePoints.Clear();
            listePoints.Add(new PointXY(0, 12));
            listePoints.Add(new PointXY(2, -16));
            listePoints.Add(new PointXY(5, -28));
            listePoints.Add(new PointXY(7, 54));

            datagrid.ItemsSource = null;
            datagrid.ItemsSource = listePoints;
            grafik1();
        }

        private void cbDrawMode1_SelectionChanged(Object sender, SelectionChangedEventArgs e) {
            if (!start) {
                grafik1();
            }
            
        }


        private void grafik1() {
            graph1.deleteCoords();
            if (listePoints.Count<2) {
                return;
            }

            decimal xmin=0, xmax = 0, ymin = 0, ymax = 0;

            List<XYGraphic.PointXY> coords = new List<XYGraphic.PointXY>();
            for (int i=0; i<listePoints.Count; i++) {
                PointXY p = listePoints[i];
                coords.Add(new XYGraphic.PointXY((double)p.X, (double)p.Y));
                if (i==0) {
                    xmin = xmax = p.X;
                    ymin= ymax = p.Y;
                }
                else {
                    if (p.X < xmin) xmin = p.X;
                    if (p.X > xmax) xmax = p.X;
                    if (p.Y < ymin) ymin = p.Y;
                    if (p.Y > ymax) ymax = p.Y;
                }
            }

            decimal xeOri = xmax;
            decimal xsw = 0;
            round(ref xmin, ref xsw, ref xmax, xeOri);
            decimal ysw = 0;
            decimal yeOri = ymax;
            round(ref ymin, ref ysw, ref ymax, yeOri);

            PointLine drawmode = PointLine.Line;
            switch (cbDrawMode1.SelectedIndex) {
                case 0:
                    drawmode = PointLine.Line;
                    break;
                case 1:
                    drawmode = PointLine.Point;
                    break;
                case 2:
                    drawmode = PointLine.LinePoint;
                    break;
            }

            graph1.setGraphic("Eingangsdaten", "X-Achse", "Y-Achse", xmin, xsw, xmax, ymin, ysw, ymax);
            graph1.setCoords1(coords, drawmode);

            //List<XYGraphic.PointXY> coords2 = new List<XYGraphic.PointXY>();
            //for (int i = 0; i < kurve2.n; i++) {
            //    coords2.Add(new XYGraphic.PointXY(kurve2.xCoords[i], kurve2.yCoords[i]));
            //}
            //graph.setCoords2(coords2);
        }

        private void round(ref decimal xa, ref decimal xsw, ref decimal xe, decimal xeOri) {
            decimal xxa = ((int)(xa * 4 - 1)) * 0.25m;
            decimal xxe = ((int)(xe * 4 + 1)) * 0.25m;


            xa = ((int)(xa * 4 - 1)) * 0.25m;
            xe = ((int)(xe * 4 + 1)) * 0.25m;

            decimal xdiff = (xe - xa) / 10.0m;
            xsw = xdiff;
            if (xsw>0.0m && xsw<0.6m) {
                xsw = 0.5m;
            }
            if (xsw < 0.0m && xsw < -0.6m) {
                xsw = -0.5m;
            }
            if (xsw > 0.0m && xsw > 0.6m) {
                xsw = (int)(xsw + 0.99m);
            }
            if (xsw < 0.0m && xsw < 0.6m) {
                xsw = (int)(xsw - 0.99m);
            }
            // nun das xe neu bestimmen !
            decimal x = xa;
            while (x<xe) {  // +xsw*0.01m 
                x += xsw;
                if (x>=xeOri) break;
            }
            xe = x;


        }

        private void bnCalcLaGrange_Click(Object sender, RoutedEventArgs e) {
            //Polynom polynom1 = new Polynom();
            //polynom1.setCoeff(0, 4);
            //polynom1.setCoeff(1, -3);
            //polynom1.setCoeff(2, 2);  // 2x² -3x+4

            //polynom1.mult(-5);

            if (listePoints.Count>15) {
                Basis.Message("Die Anzahl der Koordinaten darf maximal 15 Punkte betragen", "Hinweis");
                return;
            }



            editor.Text = "";
            StringBuilder sb = new StringBuilder();
            List<Polynom> listePolynome = new List<Polynom>();  // Anzahl der Koordinaten

            sb.AppendLine("Koordinaten");
            sb.AppendLine("       x               y");
            for (int i = 0; i < listePoints.Count; i++) {
                PointXY p = listePoints[i];
                sb.Append(p.X.ToString("0.00000").PadLeft(11));
                sb.Append("     ");
                sb.AppendLine(p.Y.ToString("0.00000").PadLeft(11));
            }
            sb.AppendLine();
            sb.AppendLine();
            sb.AppendLine("Langrange Polynome");

            for (int i = 0; i < listePoints.Count; i++) {
                Polynom polynom = new Polynom();
                PointXY p = listePoints[i];
                bool first = true;
                for (int j = 0; j < listePoints.Count; j++) {
                    if (i != j) {
                        PointXY p2 = listePoints[j];
                        if (first) {
                            if (p.X - p2.X==0.0m) {
                                Basis.ErrorMsg("Division durch Null", "Fehler");
                                return;
                            }
                            polynom.setCoeff(0, -p2.X / (p.X - p2.X));
                            polynom.setCoeff(1, 1 / (p.X - p2.X));
                            first = false;
                        }
                        else {
                            polynom.mult(-p2.X);  // mult (x-a)!
                            if (p.X - p2.X == 0.0m) {
                                Basis.ErrorMsg("Division durch Null", "Fehler");
                                return;
                            }
                            polynom.div(p.X - p2.X);
                        }
                    }
                }  // for (int j = 0; j < listePoints.Count; j++) {
                sb.Append("L(" + i + ")  =  ");
                sb.AppendLine(polynom.ToString());
                listePolynome.Add(polynom);
            }  // for (int i = 0; i < listePoints.Count; i++) {

            // Funktion ausrechnen
            polynomY.Clear();
            for (int i = 0; i < listePoints.Count; i++) {
                PointXY p = listePoints[i];
                Polynom polynom = listePolynome[i];
                polynom.multY(p.Y);
                for (int j = 0; j < polynom.coeff.Length; j++) {
                    polynomY.coeff[j] += polynom.coeff[j];
                }
            }
            sb.AppendLine();
            sb.AppendLine("Funktion");

            sb.Append("y = ");
            sb.AppendLine(polynomY.ToString());

            editor.Text = sb.ToString();
            tabcontrol.SelectedIndex = 1;

            grafik2();
        }  // bnCalcLaGrange_Click


        private void grafik2() {
            graph2.deleteCoords();
            decimal xmin = 0, xmax = 0, ymin = 0, ymax = 0;

            List<XYGraphic.PointXY> coords1 = new List<XYGraphic.PointXY>();
            for (int i = 0; i < listePoints.Count; i++) {
                PointXY p = listePoints[i];
                coords1.Add(new XYGraphic.PointXY((double)p.X, (double)p.Y));
                if (i == 0) {
                    xmin = xmax = p.X;
                    ymin = ymax = p.Y;
                }
                else {
                    if (p.X < xmin) xmin = p.X;
                    if (p.X > xmax) xmax = p.X;
                    if (p.Y < ymin) ymin = p.Y;
                    if (p.Y > ymax) ymax = p.Y;
                }
            }

            decimal listexMin = xmin;
            decimal listexMax = xmax;

            decimal xsw = 0;
            decimal xeOri = xmax;
            round(ref xmin, ref xsw, ref xmax, xeOri);

            decimal yeOri = ymax;

            listexMin -= xsw * 0.1m;
            listexMax += xsw * 0.1m;

            List<XYGraphic.PointXY> coords2 = new List<XYGraphic.PointXY>();
            decimal x = listexMin-xsw*0.1m;
            decimal y = 0;
            while (x <= listexMax + xsw * 0.01m) {
                y = polynomY.Y(x);
                coords2.Add(new XYGraphic.PointXY((double)x, (double)y));
                if (y < ymin) ymin = y;
                if (y > ymax) ymax = y;
                x += 0.05m;
            }

            
            round(ref xmin, ref xsw, ref xmax, xeOri+xsw*0.1m);
            decimal ysw = 0;
            round(ref ymin, ref ysw, ref ymax, ymax);


            graph2.setGraphic("Eingangsdaten", "X-Achse", "Y-Achse", xmin, xsw, xmax, ymin, ysw, ymax);
            graph2.setCoords1(coords1, PointLine.Point);
            graph2.setCoords2(coords2);

            if (newton) {
                //List<XYGraphic.PointXY> coords3 = new List<XYGraphic.PointXY>();
                //x = listexMin - xsw * 0.1m;
                //y = 0;
                //while (x <= listexMax + xsw * 0.01m) {
                //    y = x * x * x - 5 * x * x - 8 * x + 12;
                //    coords3.Add(new XYGraphic.PointXY((double)x, (double)y));
                //    x += 0.05m;
                //}
                //graph2.setCoords3(coords3);ddd
            }

        }


        private void Window_Closing(object sender, CancelEventArgs e) {
            e.Cancel = false;
            Basis.writeWindowPosition2Registry(this, C_REG_ADR + "\\position", "table" + dbtable);
        }

    }
}
